library value_broadcast;

class ValueBroadcast<T>{
  final Set<Function(T)> _listeners = Set();

  void addListener(final Function(T) listener) => _listeners.add(listener);

  void removeListener(final Function(T) listener) => _listeners.remove(listener);

  ValueBroadcast(this._value);
  
  T _value;

  T get value => _value;

  set value(final T update){
    if(_value != update){
      _value = update;
      _listeners.forEach((final Function(T) listener) => listener(update));
    }
  }
}